The FlexGrid control allows users to import and export content to/from an Excel (.xlsx) file asynchronously. This sample demonstrates how to do so using the saveAsync/loadAsync methods of the FlexGridXlsxConverter class.
import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './style.css';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import { getProductOrders } from './data';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
let data = getProductOrders(500), customContent = false, includeColumnHeader = false;
let grid = new wjGrid.FlexGrid('#flexgrid', {
itemsSource: data,
formatItem: formatItem,
columns: [
{ binding: 'id', header: 'ID' },
{ binding: 'start', header: 'Start Date', format: 'd' },
{ binding: 'end', header: 'End Date', format: 'd' },
{ binding: 'country', header: 'Country' },
{ binding: 'product', header: 'Product' },
{ binding: 'color', header: 'Color' },
{ binding: 'amount', header: 'Amount', format: 'c', aggregate: 'Sum' },
{ binding: 'amount2', header: 'Pending', format: 'c', aggregate: 'Sum' },
{ binding: 'discount', header: 'Discount', format: 'p1', aggregate: 'Avg' },
{ binding: 'active', header: 'Active', width: 185 }
]
});
updateGroup();
onClick('customCellContent', (e) => {
customContent = e.target.checked;
grid.invalidate();
});
onClick('importIncludeColumnHeader', (e) => {
includeColumnHeader = e.target.checked;
document.querySelector('#exportIncludeColumnHeader').checked = includeColumnHeader;
});
onClick('exportIncludeColumnHeader', (e) => {
includeColumnHeader = e.target.checked;
document.querySelector('#importIncludeColumnHeader').checked = includeColumnHeader;
});
onClick('loadXlsx', () => {
let inputEle = document.querySelector('#importFile');
if (inputEle.files[0]) {
wjGridXlsx.FlexGridXlsxConverter.loadAsync(grid, inputEle.files[0], { includeColumnHeaders: includeColumnHeader });
}
});
onClick('saveXlsx', () => {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(grid, {
includeColumnHeaders: includeColumnHeader,
includeStyles: false,
formatItem: customContent ? exportFormatItem : null
}, 'FlexGrid.xlsx');
});
// update group setting for the flex grid
function updateGroup() {
let groupNames = ['Product', 'Country', 'Amount'], cv, propName, groupDesc;
if (grid) {
// get the collection view, start update
cv = grid.collectionView;
cv.beginUpdate();
// clear existing groups
cv.groupDescriptions.clear();
// add new groups
for (let i = 0; i < groupNames.length; i++) {
propName = groupNames[i].toLowerCase();
if (propName == 'amount') {
// group amounts in ranges
// (could use the mapping function to group countries into continents,
// names into initials, etc)
groupDesc = new wjCore.PropertyGroupDescription(propName, function (item, prop) {
let value = item[prop];
if (value > 1000)
return 'Large Amounts';
if (value > 100)
return 'Medium Amounts';
if (value > 0)
return 'Small Amounts';
return 'Negative';
});
cv.groupDescriptions.push(groupDesc);
}
else if (propName) {
// group other properties by their specific values
groupDesc = new wjCore.PropertyGroupDescription(propName);
cv.groupDescriptions.push(groupDesc);
}
}
// done updating
cv.endUpdate();
}
}
function formatItem(s, e) {
let panel = e.panel, r = e.row, c = e.col, cell = e.cell;
if (panel.cellType === wjGrid.CellType.Cell) {
let binding = grid.columns[c].binding, row = grid.rows[r];
if (row instanceof wjGrid.GroupRow) {
if (row.level <= 2) {
if (binding === 'active') {
cell.innerHTML = customContent
? 'Amount/Pending: ' + Math.round(grid.getCellData(r, 'amount', false) / grid.getCellData(r, 'amount2', false) * 100) / 100
: '';
}
}
}
else {
if (binding === 'color') {
cell.style.color = customContent ? grid.getCellData(r, c, true) : '';
}
}
}
}
function exportFormatItem(args) {
let p = args.panel, row = args.row, col = args.col, xlsxCell = args.xlsxCell;
if (p.cellType === wjGrid.CellType.Cell) {
if (p.columns[col].binding === 'color') {
if (xlsxCell.value) {
if (!xlsxCell.style.font) {
xlsxCell.style.font = {};
}
xlsxCell.style.font.color = xlsxCell.value.toLowerCase();
}
}
else if (p.columns[col].binding === 'active' && p.rows[row] instanceof wjGrid.GroupRow) {
let cell = args.getFormattedCell();
xlsxCell.value = cell.textContent.trim();
}
}
}
function onClick(id, fn) {
document.querySelector('#' + id).addEventListener('click', fn);
}
}
Submit and view feedback for

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.react.grid';
import * as wjGrid from '@mescius/wijmo.grid';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import './app.css';
import { data } from './data';
function App() {
const [includeColumnHeader, setIncludeColumnHeader] = useState(false);
const [customContent, setCustomContent] = useState(false);
const flexRef = useRef(null);
const initializeFlexSheet = useEvent((flex) => {
flexRef.current = flex;
let groupNames = ['Product', 'Country', 'Amount'], cv = flex.collectionView;
// start update
cv.beginUpdate();
// clear existing groups
cv.groupDescriptions.clear();
// add new groups
for (let i = 0; i < groupNames.length; i++) {
let propName = groupNames[i].toLowerCase();
if (propName == 'amount') {
// group amounts in ranges
// (could use the mapping function to group countries into continents,
// names into initials, etc)
let groupDesc = new wjcCore.PropertyGroupDescription(propName, (item, prop) => {
let value = item[prop];
if (value > 1000)
return 'Large Amounts';
if (value > 100)
return 'Medium Amounts';
if (value > 0)
return 'Small Amounts';
return 'Negative';
});
cv.groupDescriptions.push(groupDesc);
}
else if (propName) {
// group other properties by their specific values
let groupDesc = new wjcCore.PropertyGroupDescription(propName);
cv.groupDescriptions.push(groupDesc);
}
}
// done updating
cv.endUpdate();
});
const save = () => {
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flexRef.current, {
includeColumnHeaders: includeColumnHeader,
includeStyles: false,
formatItem: customContent ? exportFormatItem : undefined
}, 'FlexGrid.xlsx');
};
const load = () => {
let fileInput = document.getElementById('importFile');
if (fileInput.files[0]) {
setCustomContent(false);
wjcGridXlsx.FlexGridXlsxConverter.loadAsync(flexRef.current, fileInput.files[0], { includeColumnHeaders: includeColumnHeader });
}
};
const customContentChanged = (event) => {
setCustomContent(event.target.checked);
wjcCore.Control.invalidateAll();
};
const formatItem = useEvent((s, e) => {
let panel = e.panel, grid = panel.grid, r = e.row, c = e.col, cell = e.cell;
if (panel.cellType === wjGrid.CellType.Cell) {
let binding = grid.columns[c].binding, row = grid.rows[r];
if (row instanceof wjGrid.GroupRow) {
if (row.level <= 2) {
if (binding === 'active') {
cell.innerHTML = customContent
? 'Amount/Pending: ' + Math.round(grid.getCellData(r, 'amount', false) / grid.getCellData(r, 'amount2', false) * 100) / 100
: '';
}
}
}
else {
if (binding === 'color') {
cell.style.color = customContent ? grid.getCellData(r, c, true) : '';
}
}
}
});
const exportFormatItem = (args) => {
var p = args.panel, row = args.row, col = args.col, xlsxCell = args.xlsxCell;
if (p.cellType === wjGrid.CellType.Cell) {
if (p.columns[col].binding === 'color') {
if (xlsxCell.value) {
if (!xlsxCell.style.font) {
xlsxCell.style.font = {};
}
xlsxCell.style.font.color = xlsxCell.value.toLowerCase();
}
}
else if (p.columns[col].binding === 'active' && p.rows[row] instanceof wjGrid.GroupRow) {
let cell = args.getFormattedCell();
xlsxCell.value = cell.textContent.trim();
xlsxCell.style.hAlign = wjcXlsx.HAlign.Left;
}
}
};
return (<main className="container-fluid">
<div className="row">
{/* the grid */}
<wjcGrid.FlexGrid itemsSource={data} initialized={initializeFlexSheet} formatItem={formatItem}>
<wjcGrid.FlexGridColumn header="ID" binding="id"/>
<wjcGrid.FlexGridColumn header="Start Date" binding="start" format="d"/>
<wjcGrid.FlexGridColumn header="End Date" binding="end" format="d"/>
<wjcGrid.FlexGridColumn header="Country" binding="country"/>
<wjcGrid.FlexGridColumn header="Product" binding="product"/>
<wjcGrid.FlexGridColumn header="Color" binding="color"/>
<wjcGrid.FlexGridColumn header="Amount" binding="amount" format="c" aggregate="Sum"/>
<wjcGrid.FlexGridColumn header="Pending" binding="amount2" format="c2" aggregate="Sum"/>
<wjcGrid.FlexGridColumn header="Discount" binding="discount" format="p1" aggregate="Avg"/>
<wjcGrid.FlexGridColumn header="Active" binding="active" width={185}/>
</wjcGrid.FlexGrid>
</div>
<div className="row">
<div className="col-md-6 col-xs-12">
<div className="form-inline well well-lg">
<input type="file" className="form-control" style={{ width: '250px' }} id="importFile" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12"/>
<button onClick={load} className="btn btn-default">Import</button>
<div className="checkbox">
<label>
<input type="checkbox" checked={includeColumnHeader} onChange={(event) => setIncludeColumnHeader(event.target.checked)}/>
Include Column Header
</label>
</div>
</div>
</div>
<div className="col-md-6 col-xs-12">
<div className="form-inline well well-lg">
<button onClick={save} className="btn btn-default">Export</button>
<div className="checkbox">
<label>
<input type="checkbox" checked={includeColumnHeader} onChange={(event) => setIncludeColumnHeader(event.target.checked)}/>
Include Column Header
</label>
</div>
<div className="checkbox">
<label>
<input type="checkbox" checked={customContent} onChange={customContentChanged}/>
Custom Cell Content
</label>
</div>
</div>
</div>
</div>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Import Export Excel Asynchronous</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
height: 400px;
margin: 6px 0;
}
.checkbox label input[type=checkbox] {
margin-right: 5px;
}
.checkbox label {
margin-right: 10px;
}
.btn {
margin-right: 5px;
}
function getProductOrders(count) {
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = ['Widget', 'Gadget', 'Doohickey'], colors = ['Black', 'White', 'Red', 'Green', 'Blue'], data = [], dt = new Date();
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25), countryId = Math.floor(Math.random() * countries.length), productId = Math.floor(Math.random() * products.length), colorId = Math.floor(Math.random() * colors.length);
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000,
amount2: Math.random() * 10000,
discount: Math.random() / 4,
active: i % 4 == 0
};
// add the item to the list
data.push(item);
}
return data;
}
export const data = getProductOrders(500);
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, Inject, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';
import { DataService } from './app.data';
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridModule, BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: any[];
includeColumnHeader = false;
customContent = false;
@ViewChild('flex', { static: true }) flex: wjcGrid.FlexGrid;
constructor(@Inject(DataService) dataSvc: DataService) {
this.data = dataSvc.getProductOrders(500);
}
initializeFlexSheet(flex: wjcGrid.FlexGrid) {
let groupNames = ['Product', 'Country', 'Amount'],
cv = flex.collectionView;
// start update
cv.beginUpdate();
// clear existing groups
cv.groupDescriptions.clear();
// add new groups
for (let i = 0; i < groupNames.length; i++) {
let propName = groupNames[i].toLowerCase();
if (propName == 'amount') {
// group amounts in ranges
// (could use the mapping function to group countries into continents,
// names into initials, etc)
let groupDesc = new wjcCore.PropertyGroupDescription(propName, (item: any, prop: string) => {
let value = item[prop];
if (value > 1000) return 'Large Amounts';
if (value > 100) return 'Medium Amounts';
if (value > 0) return 'Small Amounts';
return 'Negative';
});
cv.groupDescriptions.push(groupDesc);
} else if (propName) {
// group other properties by their specific values
let groupDesc = new wjcCore.PropertyGroupDescription(propName);
cv.groupDescriptions.push(groupDesc);
}
}
// done updating
cv.endUpdate();
}
save() {
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(
this.flex,
{
includeColumnHeaders: this.includeColumnHeader,
includeStyles: false,
formatItem: this.customContent ? this._exportFormatItem : null,
},
'FlexGrid.xlsx',
);
}
load() {
let fileInput = <HTMLInputElement>document.getElementById('importFile');
if (fileInput.files[0]) {
this.customContent = false;
wjcGridXlsx.FlexGridXlsxConverter.loadAsync(this.flex, fileInput.files[0], {
includeColumnHeaders: this.includeColumnHeader,
});
}
}
private _exportFormatItem(args: wjcGridXlsx.XlsxFormatItemEventArgs) {
var p = args.panel,
row = args.row,
col = args.col,
xlsxCell = args.xlsxCell,
cell: HTMLElement;
if (p.cellType === wjcGrid.CellType.Cell) {
if (p.columns[col].binding === 'color') {
if (xlsxCell.value) {
if (!xlsxCell.style.font) {
xlsxCell.style.font = {};
}
xlsxCell.style.font.color = (<string>xlsxCell.value).toLowerCase();
}
} else if (p.columns[col].binding === 'active' && p.rows[row] instanceof wjcGrid.GroupRow) {
cell = args.getFormattedCell();
xlsxCell.value = cell.textContent.trim();
xlsxCell.style.hAlign = wjcXlsx.HAlign.Left;
}
}
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Import Export Excel Asynchronous</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<div class="row">
<!-- the grid -->
<wj-flex-grid #flex [(itemsSource)]="data" (initialized)="initializeFlexSheet(flex)">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color" [width]="70">
@if (customContent) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<div [style.color]="cell?.item?.color?.toLowerCase()">
{{cell.item.color}}
</div>
</ng-template>
}
</wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c" aggregate="Sum"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2" aggregate="Sum"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1" aggregate="Avg"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active" [width]="170">
@if (customContent) {
<ng-template wjFlexGridCellTemplate [cellType]="'Group'" let-cell="cell">
<div style="text-align:left">
Amount/Pending: {{ cell.row.grid.getCellData(cell.row.index, 'amount', false) /
cell.row.grid.getCellData(cell.row.index, 'amount2', false) | number:'1.2-2' }}
</div>
</ng-template>
}
</wj-flex-grid-column>
</wj-flex-grid>
</div>
<div class="row">
<div class="col-md-6 col-xs-12">
<div class="form-inline well well-lg">
<input type="file" class="form-control" style="width: 250px;" id="importFile"
accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12" />
<button (click)="load()" class="btn btn-default">Import</button>
<div class="checkbox">
<label>
<input [(ngModel)]="includeColumnHeader" type="checkbox"> Include Column Header
</label>
</div>
</div>
</div>
<div class="col-md-6 col-xs-12">
<div class="form-inline well well-lg">
<button (click)="save()" class="btn btn-default">Export</button>
<div class="checkbox">
<label>
<input [(ngModel)]="includeColumnHeader" type="checkbox"> Include Column Header
</label>
</div>
<div class="checkbox">
<label>
<input [(ngModel)]="customContent" type="checkbox"> Custom Cell Content
</label>
</div>
</div>
</div>
</div>
</main>
import { Injectable } from '@angular/core';
@Injectable()
export class DataService {
getProductOrders(count: number) {
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'],
products = ['Widget', 'Gadget', 'Doohickey'],
colors = ['Black', 'White', 'Red', 'Green', 'Blue'],
data = [],
dt = new Date();
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000,
amount2: Math.random() * 10000,
discount: Math.random() / 4,
active: i % 4 == 0
};
// add the item to the list
data.push(item);
}
return data;
}
}
.wj-flexgrid {
height: 400px;
margin: 6px 0;
}
.checkbox label input[type=checkbox] {
margin-right: 5px;
}
.checkbox label {
margin-right: 10px;
}
.btn {
margin-right: 5px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<div class="row">
<!-- the grid -->
<wj-flex-grid :itemsSource="data" :initialized="initializeFlexSheet" :formatItem="formatItem">
<wj-flex-grid-column header="ID" binding="id"></wj-flex-grid-column>
<wj-flex-grid-column header="Start Date" binding="start" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="End Date" binding="end" format="d"></wj-flex-grid-column>
<wj-flex-grid-column header="Country" binding="country"></wj-flex-grid-column>
<wj-flex-grid-column header="Product" binding="product"></wj-flex-grid-column>
<wj-flex-grid-column header="Color" binding="color" :width="70"></wj-flex-grid-column>
<wj-flex-grid-column header="Amount" binding="amount" format="c" aggregate="Sum"></wj-flex-grid-column>
<wj-flex-grid-column header="Pending" binding="amount2" format="c2"
aggregate="Sum"></wj-flex-grid-column>
<wj-flex-grid-column header="Discount" binding="discount" format="p1"
aggregate="Avg"></wj-flex-grid-column>
<wj-flex-grid-column header="Active" binding="active" :width="170"></wj-flex-grid-column>
</wj-flex-grid>
</div>
<div class="row">
<div class="col-md-6 col-xs-12">
<div class="form-inline well well-lg">
<input type="file" class="form-control" style="width: 250px;" id="importFile"
accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel.sheet.macroEnabled.12">
<button @click="load()" class="btn btn-default">Import</button>
<div class="checkbox">
<label>
<input v-model="includeColumnHeader" type="checkbox"> Include Column Header
</label>
</div>
</div>
</div>
<div class="col-md-6 col-xs-12">
<div class="form-inline well well-lg">
<button @click="save()" class="btn btn-default">Export</button>
<div class="checkbox">
<label>
<input v-model="includeColumnHeader" type="checkbox"> Include Column Header
</label>
</div>
<div class="checkbox">
<label>
<input v-model="customContent" @click="customContentClick($event)" type="checkbox"> Custom
Cell Content
</label>
</div>
</div>
</div>
</div>
</main>
</template>
<script setup>
import { getProductOrders } from "./data";
import * as wjcCore from "@mescius/wijmo";
import * as wjcGrid from "@mescius/wijmo.grid";
import * as wjcXlsx from "@mescius/wijmo.xlsx";
import * as wjcGridXlsx from "@mescius/wijmo.grid.xlsx";
import * as gridPdf from "@mescius/wijmo.grid.pdf";
import { ref } from "vue";
const data = ref(getProductOrders(500));
const includeColumnHeader = ref(false);
const customContent = ref(false);
const flex = ref(null);
function initializeFlexSheet(flexref) {
flex.value = flexref;
let groupNames = ["Product", "Country", "Amount"],
cv = flexref.collectionView;
// start update
cv.beginUpdate();
// clear existing groups
cv.groupDescriptions.clear();
// add new groups
for (let i = 0; i < groupNames.length; i++) {
let propName = groupNames[i].toLowerCase();
if (propName == "amount") {
// group amounts in ranges
// (could use the mapping function to group countries into continents,
// names into initials, etc)
let groupDesc = new wjcCore.PropertyGroupDescription(propName, (item, prop) => {
let value = item[prop];
if (value > 1000) return "Large Amounts";
if (value > 100) return "Medium Amounts";
if (value > 0) return "Small Amounts";
return "Negative";
});
cv.groupDescriptions.push(groupDesc);
} else if (propName) {
// group other properties by their specific values
let groupDesc = new wjcCore.PropertyGroupDescription(propName);
cv.groupDescriptions.push(groupDesc);
}
}
// done updating
cv.endUpdate();
}
function save() {
wjcGridXlsx.FlexGridXlsxConverter.saveAsync(
flex.value,
{
includeColumnHeaders: includeColumnHeader.value,
includeStyles: false,
formatItem: customContent.value ? exportFormatItem : null,
},
"FlexGrid.xlsx",
);
}
function load() {
let fileInput = document.getElementById("importFile");
if (fileInput.files[0]) {
customContent.value = false;
wjcGridXlsx.FlexGridXlsxConverter.loadAsync(flex.value, fileInput.files[0], { includeColumnHeaders: includeColumnHeader.value });
}
}
function customContentClick(e) {
flex.value.invalidate();
}
function formatItem(grid, e) {
let panel = e.panel,
r = e.row,
c = e.col,
cell = e.cell;
if (panel.cellType === wjcGrid.CellType.Cell) {
let binding = grid.columns[c].binding,
row = grid.rows[r];
if (row instanceof wjcGrid.GroupRow) {
if (row.level <= 2) {
if (binding === "active") {
cell.innerHTML = customContent.value ? "Amount/Pending: " + Math.round((grid.getCellData(r, "amount", false) / grid.getCellData(r, "amount2", false)) * 100) / 100 : "";
}
}
} else {
if (binding === "color") {
cell.style.color = customContent.value ? grid.getCellData(r, c, true) : "";
}
}
}
}
function exportFormatItem(args) {
var p = args.panel,
row = args.row,
col = args.col,
xlsxCell = args.xlsxCell;
if (p.cellType === wjcGrid.CellType.Cell) {
if (p.columns[col].binding === "color") {
if (xlsxCell.value) {
if (!xlsxCell.style.font) {
xlsxCell.style.font = {};
}
xlsxCell.style.font.color = xlsxCell.value.toLowerCase();
}
} else if (p.columns[col].binding === "active" && p.rows[row] instanceof wjcGrid.GroupRow) {
let cell = args.getFormattedCell();
xlsxCell.value = cell.textContent.trim();
xlsxCell.style.hAlign = wjcXlsx.HAlign.Left;
}
}
}
</script>
<style>
.wj-flexgrid {
height: 400px;
margin: 6px 0;
}
.checkbox label input[type=checkbox] {
margin-right: 5px;
}
.checkbox label {
margin-right: 10px;
}
.btn {
margin-right: 5px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Using a custom font</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getProductOrders(count) {
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'],
products = ['Widget', 'Gadget', 'Doohickey'],
colors = ['Black', 'White', 'Red', 'Green', 'Blue'],
data = [],
dt = new Date();
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let date = new Date(dt.getFullYear(), i % 12, 25),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
// create the item
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
amount: Math.random() * 10000,
amount2: Math.random() * 10000,
discount: Math.random() / 4,
active: i % 4 == 0
};
// add the item to the list
data.push(item);
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);